/* A Bison parser, made from parse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	ASM_KEYW	257
# define	ATTRIBUTE_KEYW	258
# define	AUTO_KEYW	259
# define	BOOL_KEYW	260
# define	CHAR_KEYW	261
# define	CONST_KEYW	262
# define	DOUBLE_KEYW	263
# define	ENUM_KEYW	264
# define	EXTERN_KEYW	265
# define	FLOAT_KEYW	266
# define	INLINE_KEYW	267
# define	INT_KEYW	268
# define	LONG_KEYW	269
# define	REGISTER_KEYW	270
# define	RESTRICT_KEYW	271
# define	SHORT_KEYW	272
# define	SIGNED_KEYW	273
# define	STATIC_KEYW	274
# define	STRUCT_KEYW	275
# define	TYPEDEF_KEYW	276
# define	UNION_KEYW	277
# define	UNSIGNED_KEYW	278
# define	VOID_KEYW	279
# define	VOLATILE_KEYW	280
# define	EXPORT_SYMBOL_KEYW	281
# define	ASM_PHRASE	282
# define	ATTRIBUTE_PHRASE	283
# define	BRACE_PHRASE	284
# define	BRACKET_PHRASE	285
# define	EXPRESSION_PHRASE	286
# define	CHAR	287
# define	DOTS	288
# define	IDENT	289
# define	INT	290
# define	REAL	291
# define	STRING	292
# define	TYPE	293
# define	OTHER	294
# define	FILENAME	295

#line 24 "parse.y"


#include <assert.h>
#include "genksyms.h"

static int is_typedef;
static int is_extern;
static char *current_name;
static struct string_list *decl_spec;

static void yyerror(const char *);

static inline void
remove_node(struct string_list **p)
{
  struct string_list *node = *p;
  *p = node->next;
  free_node(node);
}

static inline void
remove_list(struct string_list **pb, struct string_list **pe)
{
  struct string_list *b = *pb, *e = *pe;
  *pb = e;
  free_list(b, e);
}

#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		168
#define	YYFLAG		-32768
#define	YYNTBASE	51

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 295 ? yytranslate[x] : 95)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      46,    47,    45,     2,    44,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    50,    42,
       2,    48,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    49,     2,    43,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     5,     6,     9,    10,    14,    16,    18,
      20,    22,    25,    28,    32,    33,    35,    37,    41,    46,
      47,    49,    51,    54,    56,    58,    60,    62,    64,    66,
      68,    70,    72,    75,    78,    81,    85,    89,    93,    96,
      99,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   127,   128,   130,   132,   135,   137,   139,
     141,   143,   146,   148,   150,   155,   160,   163,   167,   171,
     174,   176,   178,   180,   185,   190,   193,   197,   201,   204,
     206,   210,   211,   213,   215,   219,   222,   225,   227,   228,
     230,   232,   237,   242,   245,   249,   253,   257,   258,   260,
     263,   267,   271,   272,   274,   276,   279,   283,   286,   287,
     289,   291,   295,   298,   301,   303,   306,   307,   309,   312,
     313,   315
};
static const short yyrhs[] =
{
      52,     0,    51,    52,     0,     0,    53,    54,     0,     0,
      22,    55,    56,     0,    56,     0,    80,     0,    92,     0,
      94,     0,     1,    42,     0,     1,    43,     0,    60,    57,
      42,     0,     0,    58,     0,    59,     0,    58,    44,    59,
       0,    70,    93,    91,    81,     0,     0,    61,     0,    62,
       0,    61,    62,     0,    63,     0,    64,     0,     5,     0,
      16,     0,    20,     0,    11,     0,    13,     0,    65,     0,
      69,     0,    21,    35,     0,    23,    35,     0,    10,    35,
       0,    21,    35,    83,     0,    23,    35,    83,     0,    10,
      35,    30,     0,    10,    30,     0,    21,    83,     0,    23,
      83,     0,     7,     0,    18,     0,    14,     0,    15,     0,
      19,     0,    24,     0,    12,     0,     9,     0,    25,     0,
       6,     0,    39,     0,    45,    67,     0,     0,    68,     0,
      69,     0,    68,    69,     0,     8,     0,    26,     0,    29,
       0,    17,     0,    66,    70,     0,    71,     0,    35,     0,
      71,    46,    74,    47,     0,    71,    46,     1,    47,     0,
      71,    31,     0,    46,    70,    47,     0,    46,     1,    47,
       0,    66,    72,     0,    73,     0,    35,     0,    39,     0,
      73,    46,    74,    47,     0,    73,    46,     1,    47,     0,
      73,    31,     0,    46,    72,    47,     0,    46,     1,    47,
       0,    75,    34,     0,    75,     0,    76,    44,    34,     0,
       0,    76,     0,    77,     0,    76,    44,    77,     0,    61,
      78,     0,    66,    78,     0,    79,     0,     0,    35,     0,
      39,     0,    79,    46,    74,    47,     0,    79,    46,     1,
      47,     0,    79,    31,     0,    46,    78,    47,     0,    46,
       1,    47,     0,    60,    70,    30,     0,     0,    82,     0,
      48,    32,     0,    49,    84,    43,     0,    49,     1,    43,
       0,     0,    85,     0,    86,     0,    85,    86,     0,    60,
      87,    42,     0,     1,    42,     0,     0,    88,     0,    89,
       0,    88,    44,    89,     0,    72,    91,     0,    35,    90,
       0,    90,     0,    50,    32,     0,     0,    29,     0,    28,
      42,     0,     0,    28,     0,    27,    46,    35,    47,    42,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    99,   101,   104,   104,   110,   110,   113,   114,   115,
     116,   117,   118,   121,   135,   137,   140,   149,   161,   167,
     169,   172,   174,   177,   185,   188,   190,   191,   192,   193,
     196,   198,   202,   204,   206,   210,   217,   224,   233,   234,
     235,   238,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   252,   257,   259,   262,   264,   267,   268,   268,
     269,   276,   278,   281,   291,   293,   295,   297,   299,   305,
     307,   310,   312,   313,   315,   317,   319,   321,   325,   327,
     328,   331,   333,   336,   338,   342,   347,   350,   353,   355,
     364,   369,   371,   373,   375,   377,   381,   390,   392,   396,
     401,   403,   406,   408,   411,   413,   416,   419,   423,   425,
     428,   430,   433,   435,   436,   439,   443,   445,   448,   452,
     454,   457
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "ASM_KEYW", "ATTRIBUTE_KEYW", "AUTO_KEYW", 
  "BOOL_KEYW", "CHAR_KEYW", "CONST_KEYW", "DOUBLE_KEYW", "ENUM_KEYW", 
  "EXTERN_KEYW", "FLOAT_KEYW", "INLINE_KEYW", "INT_KEYW", "LONG_KEYW", 
  "REGISTER_KEYW", "RESTRICT_KEYW", "SHORT_KEYW", "SIGNED_KEYW", 
  "STATIC_KEYW", "STRUCT_KEYW", "TYPEDEF_KEYW", "UNION_KEYW", 
  "UNSIGNED_KEYW", "VOID_KEYW", "VOLATILE_KEYW", "EXPORT_SYMBOL_KEYW", 
  "ASM_PHRASE", "ATTRIBUTE_PHRASE", "BRACE_PHRASE", "BRACKET_PHRASE", 
  "EXPRESSION_PHRASE", "CHAR", "DOTS", "IDENT", "INT", "REAL", "STRING", 
  "TYPE", "OTHER", "FILENAME", "';'", "'}'", "','", "'*'", "'('", "')'", 
  "'='", "'{'", "':'", "declaration_seq", "declaration", "@1", 
  "declaration1", "@2", "simple_declaration", "init_declarator_list_opt", 
  "init_declarator_list", "init_declarator", "decl_specifier_seq_opt", 
  "decl_specifier_seq", "decl_specifier", "storage_class_specifier", 
  "type_specifier", "simple_type_specifier", "ptr_operator", 
  "cvar_qualifier_seq_opt", "cvar_qualifier_seq", "cvar_qualifier", 
  "declarator", "direct_declarator", "nested_declarator", 
  "direct_nested_declarator", "parameter_declaration_clause", 
  "parameter_declaration_list_opt", "parameter_declaration_list", 
  "parameter_declaration", "m_abstract_declarator", 
  "direct_m_abstract_declarator", "function_definition", 
  "initializer_opt", "initializer", "class_body", 
  "member_specification_opt", "member_specification", 
  "member_declaration", "member_declarator_list_opt", 
  "member_declarator_list", "member_declarator", 
  "member_bitfield_declarator", "attribute_opt", "asm_definition", 
  "asm_phrase_opt", "export_definition", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    51,    51,    53,    52,    55,    54,    54,    54,    54,
      54,    54,    54,    56,    57,    57,    58,    58,    59,    60,
      60,    61,    61,    62,    62,    63,    63,    63,    63,    63,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    66,    67,    67,    68,    68,    69,    69,    69,
      69,    70,    70,    71,    71,    71,    71,    71,    71,    72,
      72,    73,    73,    73,    73,    73,    73,    73,    74,    74,
      74,    75,    75,    76,    76,    77,    78,    78,    79,    79,
      79,    79,    79,    79,    79,    79,    80,    81,    81,    82,
      83,    83,    84,    84,    85,    85,    86,    86,    87,    87,
      88,    88,    89,    89,    89,    90,    91,    91,    92,    93,
      93,    94
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     0,     2,     0,     3,     1,     1,     1,
       1,     2,     2,     3,     0,     1,     1,     3,     4,     0,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     3,     3,     3,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     0,     1,     1,     2,     1,     1,     1,
       1,     2,     1,     1,     4,     4,     2,     3,     3,     2,
       1,     1,     1,     4,     4,     2,     3,     3,     2,     1,
       3,     0,     1,     1,     3,     2,     2,     1,     0,     1,
       1,     4,     4,     2,     3,     3,     3,     0,     1,     2,
       3,     3,     0,     1,     1,     2,     3,     2,     0,     1,
       1,     3,     2,     2,     1,     2,     0,     1,     2,     0,
       1,     5
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       3,     3,     1,     0,     2,     0,    25,    50,    41,    57,
      48,     0,    28,    47,    29,    43,    44,    26,    60,    42,
      45,    27,     0,     5,     0,    46,    49,    58,     0,     0,
      59,    51,     4,     7,    14,    20,    21,    23,    24,    30,
      31,     8,     9,    10,    11,    12,    38,    34,    32,     0,
      39,    19,    33,    40,     0,   118,    63,    53,     0,     0,
      15,    16,     0,   119,    62,    22,    37,    35,     0,   108,
       0,     0,   104,     6,    14,    36,     0,    52,    54,    55,
       0,     0,    13,     0,    61,   120,    96,   116,    66,     0,
     107,   101,    71,    72,     0,     0,     0,   116,    70,     0,
     109,   110,   114,   100,     0,   105,   119,     0,    56,    68,
      67,    17,   117,    97,     0,    88,     0,    79,    82,    83,
     113,     0,    71,     0,   115,    69,   112,    75,     0,   106,
       0,   121,     0,    18,    98,    65,    89,    51,     0,    88,
      85,    87,    64,    78,     0,    77,    76,     0,     0,   111,
      99,     0,    90,     0,    86,    93,     0,    80,    84,    74,
      73,    95,    94,     0,     0,    92,    91,     0,     0
};

static const short yydefgoto[] =
{
       1,     2,     3,    32,    51,    33,    59,    60,    61,    69,
      35,    36,    37,    38,    39,    62,    77,    78,    40,   106,
      64,    97,    98,   116,   117,   118,   119,   140,   141,    41,
     133,   134,    50,    70,    71,    72,    99,   100,   101,   102,
     113,    42,    87,    43
};

static const short yypact[] =
{
  -32768,    40,-32768,   297,-32768,   -30,-32768,-32768,-32768,-32768,
  -32768,   -16,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,     4,-32768,    11,-32768,-32768,-32768,     6,    17,
  -32768,-32768,-32768,-32768,    63,   416,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    31,    23,    76,
  -32768,   416,    23,-32768,    33,-32768,-32768,    -2,    10,    24,
      35,-32768,    63,   -12,   -21,-32768,-32768,-32768,     1,    28,
      61,   122,-32768,-32768,    63,-32768,    65,-32768,    -2,-32768,
      73,    77,-32768,    63,-32768,-32768,-32768,    96,-32768,   168,
  -32768,-32768,    94,-32768,    19,   117,    68,    96,   -14,   108,
     109,-32768,-32768,-32768,   110,-32768,   126,   113,-32768,-32768,
  -32768,-32768,-32768,   111,   115,   339,   116,   124,   112,-32768,
  -32768,   119,-32768,   123,-32768,-32768,-32768,-32768,   211,-32768,
      28,-32768,   128,-32768,-32768,-32768,-32768,-32768,     3,    71,
  -32768,    -9,-32768,-32768,   381,-32768,-32768,   143,   148,-32768,
  -32768,   149,-32768,   151,-32768,-32768,   254,-32768,-32768,-32768,
  -32768,-32768,-32768,   152,   153,-32768,-32768,   171,-32768
};

static const short yypgoto[] =
{
  -32768,   200,-32768,-32768,-32768,   154,-32768,-32768,   120,     0,
     -87,   -35,-32768,-32768,-32768,   -68,-32768,-32768,   -48,   -29,
  -32768,   -73,-32768,  -120,-32768,-32768,    60,   -63,-32768,-32768,
  -32768,-32768,   -17,-32768,-32768,   135,-32768,-32768,    78,   118,
     114,-32768,-32768,-32768
};


#define	YYLAST		455


static const short yytable[] =
{
      65,    96,   115,    34,   151,    63,     9,    53,   148,    79,
      88,    80,    44,    45,    46,    18,    85,   127,    86,    47,
     121,   123,   155,   125,    27,    89,    96,    30,    96,    81,
     108,    67,   128,    84,   -88,    75,   164,   156,   136,    48,
     167,   115,   152,    90,    91,    56,    52,   139,    57,   138,
     -88,    74,    54,    49,   122,    57,    58,   115,    93,    55,
      49,    66,    96,    92,    57,    94,    82,    93,    76,   115,
     139,   139,    49,    57,    94,   153,   154,    68,    95,    83,
      65,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    56,    24,
      25,    26,    27,   122,   103,    30,   136,    93,    57,    58,
     152,   -19,   107,    57,    94,    31,    57,   138,   -19,  -102,
     109,   -19,   -19,   104,   110,   112,   -19,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    95,    24,    25,    26,    27,   124,
     129,    30,    90,   130,    85,   131,   144,   -19,   143,   132,
     150,    31,   135,   142,   -19,  -103,   145,   -19,   -19,   114,
     146,   168,   -19,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
     159,    24,    25,    26,    27,   160,   161,    30,   162,   165,
     166,     4,   -81,   111,   158,    73,   105,    31,   149,     0,
     120,   126,   147,     0,     0,   -81,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,     0,    24,    25,    26,    27,     0,     0,
      30,     0,     0,     0,     0,   -81,     0,     0,     0,     0,
      31,     0,     0,     0,     0,   163,     0,     0,   -81,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,     0,    24,    25,    26,
      27,     0,     0,    30,     0,     0,     0,     0,   -81,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     5,     0,
       0,   -81,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,     0,     0,     0,
       0,     0,   -19,     0,     0,     0,    31,     0,     0,   -19,
       0,     0,   -19,   -19,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,    24,    25,    26,    27,     0,     0,    30,     0,
       0,     0,     0,     0,   136,     0,     0,     0,   137,     0,
       0,     0,     0,     0,    57,   138,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,     0,    24,    25,    26,    27,     0,     0,
      30,     0,     0,     0,     0,   157,     0,     0,     0,     0,
      31,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,     0,    24,
      25,    26,    27,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    31
};

static const short yycheck[] =
{
      35,    69,    89,     3,     1,    34,     8,    24,   128,    57,
      31,     1,    42,    43,    30,    17,    28,    31,    30,    35,
       1,    94,    31,    96,    26,    46,    94,    29,    96,    58,
      78,    48,    46,    62,    31,    52,   156,    46,    35,    35,
       0,   128,    39,    42,    43,    35,    35,   115,    45,    46,
      47,    51,    46,    49,    35,    45,    46,   144,    39,    42,
      49,    30,   130,    35,    45,    46,    42,    39,    35,   156,
     138,   139,    49,    45,    46,   138,   139,     1,    50,    44,
     115,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    35,    23,
      24,    25,    26,    35,    43,    29,    35,    39,    45,    46,
      39,    35,    47,    45,    46,    39,    45,    46,    42,    43,
      47,    45,    46,     1,    47,    29,    50,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    50,    23,    24,    25,    26,    32,
      42,    29,    42,    44,    28,    42,    44,    35,    34,    48,
      32,    39,    47,    47,    42,    43,    47,    45,    46,     1,
      47,     0,    50,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      47,    23,    24,    25,    26,    47,    47,    29,    47,    47,
      47,     1,    34,    83,   144,    51,    71,    39,   130,    -1,
      92,    97,     1,    -1,    -1,    47,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,     1,    -1,    -1,    47,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    -1,    -1,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    47,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    39,    -1,    -1,    42,
      -1,    -1,    45,    46,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      39,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/lib/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 105 "parse.y"
{ is_typedef = 0; is_extern = 0; current_name = NULL; decl_spec = NULL; ;
    break;}
case 4:
#line 107 "parse.y"
{ free_list(*yyvsp[0], NULL); *yyvsp[0] = NULL; ;
    break;}
case 5:
#line 111 "parse.y"
{ is_typedef = 1; ;
    break;}
case 6:
#line 112 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 11:
#line 117 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 12:
#line 118 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 13:
#line 123 "parse.y"
{ if (current_name) {
		    struct string_list *decl = (*yyvsp[0])->next;
		    (*yyvsp[0])->next = NULL;
		    add_symbol(current_name,
			       is_typedef ? SYM_TYPEDEF : SYM_NORMAL,
			       decl, is_extern);
		    current_name = NULL;
		  }
		  yyval = yyvsp[0];
		;
    break;}
case 14:
#line 136 "parse.y"
{ yyval = NULL; ;
    break;}
case 16:
#line 142 "parse.y"
{ struct string_list *decl = *yyvsp[0];
		  *yyvsp[0] = NULL;
		  add_symbol(current_name,
			     is_typedef ? SYM_TYPEDEF : SYM_NORMAL, decl, is_extern);
		  current_name = NULL;
		  yyval = yyvsp[0];
		;
    break;}
case 17:
#line 150 "parse.y"
{ struct string_list *decl = *yyvsp[0];
		  *yyvsp[0] = NULL;
		  free_list(*yyvsp[-1], NULL);
		  *yyvsp[-1] = decl_spec;
		  add_symbol(current_name,
			     is_typedef ? SYM_TYPEDEF : SYM_NORMAL, decl, is_extern);
		  current_name = NULL;
		  yyval = yyvsp[0];
		;
    break;}
case 18:
#line 163 "parse.y"
{ yyval = yyvsp[0] ? yyvsp[0] : yyvsp[-1] ? yyvsp[-1] : yyvsp[-2] ? yyvsp[-2] : yyvsp[-3]; ;
    break;}
case 19:
#line 168 "parse.y"
{ decl_spec = NULL; ;
    break;}
case 21:
#line 173 "parse.y"
{ decl_spec = *yyvsp[0]; ;
    break;}
case 22:
#line 174 "parse.y"
{ decl_spec = *yyvsp[0]; ;
    break;}
case 23:
#line 179 "parse.y"
{ /* Version 2 checksumming ignores storage class, as that
		     is really irrelevant to the linkage.  */
		  if (checksum_version > 1)
		    remove_node(yyvsp[0]);
		  yyval = yyvsp[0];
		;
    break;}
case 28:
#line 192 "parse.y"
{ is_extern = 1; yyval = yyvsp[0]; ;
    break;}
case 29:
#line 193 "parse.y"
{ is_extern = 0; yyval = yyvsp[0]; ;
    break;}
case 32:
#line 203 "parse.y"
{ remove_node(yyvsp[-1]); (*yyvsp[0])->tag = SYM_STRUCT; yyval = yyvsp[0]; ;
    break;}
case 33:
#line 205 "parse.y"
{ remove_node(yyvsp[-1]); (*yyvsp[0])->tag = SYM_UNION; yyval = yyvsp[0]; ;
    break;}
case 34:
#line 207 "parse.y"
{ remove_node(yyvsp[-1]); (*yyvsp[0])->tag = SYM_ENUM; yyval = yyvsp[0]; ;
    break;}
case 35:
#line 211 "parse.y"
{ struct string_list *s = *yyvsp[0], *i = *yyvsp[-1], *r;
		  r = copy_node(i); r->tag = SYM_STRUCT;
		  r->next = (*yyvsp[-2])->next; *yyvsp[0] = r; (*yyvsp[-2])->next = NULL;
		  add_symbol(i->string, SYM_STRUCT, s, is_extern);
		  yyval = yyvsp[0];
		;
    break;}
case 36:
#line 218 "parse.y"
{ struct string_list *s = *yyvsp[0], *i = *yyvsp[-1], *r;
		  r = copy_node(i); r->tag = SYM_UNION;
		  r->next = (*yyvsp[-2])->next; *yyvsp[0] = r; (*yyvsp[-2])->next = NULL;
		  add_symbol(i->string, SYM_UNION, s, is_extern);
		  yyval = yyvsp[0];
		;
    break;}
case 37:
#line 225 "parse.y"
{ struct string_list *s = *yyvsp[0], *i = *yyvsp[-1], *r;
		  r = copy_node(i); r->tag = SYM_ENUM;
		  r->next = (*yyvsp[-2])->next; *yyvsp[0] = r; (*yyvsp[-2])->next = NULL;
		  add_symbol(i->string, SYM_ENUM, s, is_extern);
		  yyval = yyvsp[0];
		;
    break;}
case 38:
#line 233 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 39:
#line 234 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 40:
#line 235 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 51:
#line 249 "parse.y"
{ (*yyvsp[0])->tag = SYM_TYPEDEF; yyval = yyvsp[0]; ;
    break;}
case 52:
#line 254 "parse.y"
{ yyval = yyvsp[0] ? yyvsp[0] : yyvsp[-1]; ;
    break;}
case 53:
#line 258 "parse.y"
{ yyval = NULL; ;
    break;}
case 56:
#line 264 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 60:
#line 270 "parse.y"
{ /* restrict has no effect in prototypes so ignore it */
		  remove_node(yyvsp[0]);
		  yyval = yyvsp[0];
		;
    break;}
case 61:
#line 277 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 63:
#line 283 "parse.y"
{ if (current_name != NULL) {
		    error_with_pos("unexpected second declaration name");
		    YYERROR;
		  } else {
		    current_name = (*yyvsp[0])->string;
		    yyval = yyvsp[0];
		  }
		;
    break;}
case 64:
#line 292 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 65:
#line 294 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 66:
#line 296 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 67:
#line 298 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 68:
#line 300 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 69:
#line 306 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 73:
#line 314 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 74:
#line 316 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 75:
#line 318 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 76:
#line 320 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 77:
#line 322 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 78:
#line 326 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 80:
#line 328 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 81:
#line 332 "parse.y"
{ yyval = NULL; ;
    break;}
case 84:
#line 339 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 85:
#line 344 "parse.y"
{ yyval = yyvsp[0] ? yyvsp[0] : yyvsp[-1]; ;
    break;}
case 86:
#line 349 "parse.y"
{ yyval = yyvsp[0] ? yyvsp[0] : yyvsp[-1]; ;
    break;}
case 88:
#line 354 "parse.y"
{ yyval = NULL; ;
    break;}
case 89:
#line 356 "parse.y"
{ /* For version 2 checksums, we don't want to remember
		     private parameter names.  */
		  if (checksum_version > 1)
		    remove_node(yyvsp[0]);
		  yyval = yyvsp[0];
		;
    break;}
case 90:
#line 365 "parse.y"
{ if (checksum_version > 1)
		    remove_node(yyvsp[0]);
		  yyval = yyvsp[0];
		;
    break;}
case 91:
#line 370 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 92:
#line 372 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 93:
#line 374 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 94:
#line 376 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 95:
#line 378 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 96:
#line 383 "parse.y"
{ struct string_list *decl = *yyvsp[-1];
		  *yyvsp[-1] = NULL;
		  add_symbol(current_name, SYM_NORMAL, decl, is_extern);
		  yyval = yyvsp[0];
		;
    break;}
case 97:
#line 391 "parse.y"
{ yyval = NULL; ;
    break;}
case 99:
#line 398 "parse.y"
{ remove_list(yyvsp[0], &(*yyvsp[-1])->next); yyval = yyvsp[0]; ;
    break;}
case 100:
#line 402 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 101:
#line 403 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 102:
#line 407 "parse.y"
{ yyval = NULL; ;
    break;}
case 105:
#line 413 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 106:
#line 418 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 107:
#line 420 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 108:
#line 424 "parse.y"
{ yyval = NULL; ;
    break;}
case 111:
#line 430 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 112:
#line 434 "parse.y"
{ yyval = yyvsp[0] ? yyvsp[0] : yyvsp[-1]; ;
    break;}
case 113:
#line 435 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 115:
#line 440 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 116:
#line 444 "parse.y"
{ yyval = NULL; ;
    break;}
case 118:
#line 449 "parse.y"
{ yyval = yyvsp[0]; ;
    break;}
case 119:
#line 453 "parse.y"
{ yyval = NULL; ;
    break;}
case 121:
#line 459 "parse.y"
{ export_symbol((*yyvsp[-2])->string); yyval = yyvsp[0]; ;
    break;}
}

#line 705 "/usr/lib/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 463 "parse.y"


static void
yyerror(const char *e)
{
  error_with_pos("%s", e);
}
